regina::GraphTriple Class Reference
Standard 3-Manifolds

Represents a closed graph manifold formed by joining three bounded Seifert fibred spaces along their torus boundaries. More...

`#include <manifold/graphtriple.h>`

Inheritance diagram for regina::GraphTriple:

## Public Member Functions

| GraphTriple (SFSpace *end0, SFSpace *centre, SFSpace *end1, const Matrix2 &matchingReln0, const Matrix2 &matchingReln1)
| Creates a new graph manifold from three bounded Seifert fibred spaces, as described in the class notes. More...
| ~GraphTriple ()
| Destroys this structure along with the component Seifert fibred spaces and matching matrices. More...
const SFSpace & | end (unsigned which) const
| Returns a reference to one of the two end spaces. More...
const SFSpace & | centre () const
| Returns a reference to the central space. More...
const Matrix2 & | matchingReln (unsigned which) const
| Returns a reference to the 2-by-2 matrix describing how the two requested bounded Seifert fibred spaces are joined together. More...
bool | operator< (const GraphTriple &compare) const
| Determines in a fairly ad-hoc fashion whether this representation of this space is "smaller" than the given representation of the given space. More...
AbelianGroup * | homology () const
| Returns the first homology group of this 3-manifold, if such a routine has been implemented. More...
bool | isHyperbolic () const
| Returns whether or not this is a finite-volume hyperbolic manifold. More...
std::ostream & | writeName (std::ostream &out) const
| Writes the common name of this 3-manifold as a human-readable string to the given output stream. More...
std::ostream & | writeTeXName (std::ostream &out) const
| Writes the common name of this 3-manifold in TeX format to the given output stream. More...
std::string | name () const
| Returns the common name of this 3-manifold as a human-readable string. More...
std::string | TeXName () const
| Returns the common name of this 3-manifold in TeX format. More...
std::string | structure () const
| Returns details of the structure of this 3-manifold that might not be evident from its common name. More...
virtual Triangulation< 3 > * | construct () const
| Returns a triangulation of this 3-manifold, if such a construction has been implemented. More...
AbelianGroup * | homologyH1 () const
| Returns the first homology group of this 3-manifold, if such a routine has been implemented. More...
bool | operator< (const Manifold &compare) const
| Determines in a fairly ad-hoc fashion whether this representation of this 3-manifold is "smaller" than the given representation of the given 3-manifold. More...
virtual std::ostream & | writeStructure (std::ostream &out) const
| Writes details of the structure of this 3-manifold that might not be evident from its common name to the given output stream. More...
void | writeTextShort (std::ostream &out) const
| Writes a short text representation of this object to the given output stream. More...
void | writeTextLong (std::ostream &out) const
| Writes a detailed text representation of this object to the given output stream. More...
std::string | str () const
| Returns a short text representation of this object. More...
std::string | utf8 () const
| Returns a short text representation of this object using unicode characters. More...
std::string | detail () const
| Returns a detailed text representation of this object. More...

## Detailed Description

Represents a closed graph manifold formed by joining three bounded Seifert fibred spaces along their torus boundaries.

There must be one Seifert fibred space at either end, each with a single torus boundary (corresponding to a single puncture in the base orbifold, with no fibre-reversing twist around this puncture). Each of these end spaces is joined to the space in the centre, which has two disjoint torus boundaries (corresponding to two punctures in the base orbifold, again with no fibre-reversing twists around these punctures).

This configuration is illustrated in the diagram below. The large boxes represent the bounded Seifert fibred spaces, and the small tunnels show how their boundaries are joined.

        /---------------\   /-----------------\   /---------------\
        |               |   |                 |   |               |
        |  End space 0   ---   Central space   ---   End space 1  |
        |                ---                   ---                |
        |               |   |                 |   |               |
        ---------------/   -----------------/   ---------------/

The way in which each pair of spaces is joined is specified by a 2-by-2 matrix. This matrix expresses the locations of the fibres and base orbifold of the corresponding end space in terms of the central space. Note that these are not the same matrices that appear in the manifold name in the census data files! See the warning below.

More specifically, consider the matrix M that describes the joining of the central space and the first end space (marked above as end space 0). Suppose that f and o are generators of the common boundary torus, where f represents a directed fibre in the central space and o represents the oriented boundary of the corresponding base orbifold. Likewise, let f0 and o0 be generators of the common boundary torus representing a directed fibre and the base orbifold of the first end space. Then the curves f, o, f0 and o0 are related as follows:

        [f0]       [f ]
        [  ] = M * [  ]
        [o0]       [o ]

Likewise, let matrix M' describe the joining of the central space and the second end space (marked in the diagram above as end space 1). Let f' and o' be curves on the common boundary torus representing the fibres and the base orbifold of the central space, and let f1 and o1 be curves on this same torus representing the fibres and the base orbifold of the second end space. Then the curves f', o', f1 and o1 are related as follows:

        [f1]        [f']
        [  ] = M' * [  ]
        [o1]        [o']

See the page on Notation for Seifert fibred spaces for details on some of the terminology used above.

The optional Manifold routine homology() is implemented, but the optional routine construct() is not.

Warning
  The 2-by-2 matrices used in this class are not the same matrices that appear in the manifold name returned by name() and TeXName() and seen in the census data files. The matrices used in this class work from the inside out, describing the boundary torus on each end space in terms of a boundary torus on the central space. The matrices used in the manifold name work from left to right in the diagram above, describing a boundary torus on the central space or rightmost end space in terms of a boundary torus on the leftmost end space or central space respectively. The upshot of all this is that the first matrix becomes inverted (and the second matrix remains unchanged). It is likely that future versions of Regina will replace this class with a more general class that (amongst other things) removes this inconsistency.

Todo:
  Optimise: Speed up homology calculations involving orientable base spaces by adding rank afterwards, instead of adding generators for genus into the presentation matrix.

## Constructor & Destructor Documentation

## GraphTriple()

regina::GraphTriple::GraphTriple | ( | SFSpace * | end0,
|  | SFSpace * | centre,
|  | SFSpace * | end1,
|  | const Matrix2 & | matchingReln0,
|  | const Matrix2 & | matchingReln1
| ) |  |

inline

Creates a new graph manifold from three bounded Seifert fibred spaces, as described in the class notes.

The three Seifert fibred spaces and both 2-by-2 matching matrices are passed separately.

Note that the new object will take ownership of the three given Seifert fibred spaces, and when this object is destroyed the Seifert fibred spaces will be destroyed also.

Precondition
  Spaces end0 and end1 each have a single torus boundary, corresponding to a single untwisted puncture in the base orbifold.
  Space centre has two disjoint torus boundaries, corresponding to two untwisted punctures in the base orbifold.
  Each of the given matrices has determinant +1 or -1.

Python:
  In Python, this constructor clones its SFSpace arguments instead of claiming ownership of them.

Parameters

  end0 | the first end space, as described in the class notes.
  centre | the central space, as described in the class notes.
  end1 | the second end space, as described in the class notes.
  matchingReln0 | the 2-by-2 matching matrix that specifies how spaces end0 and centre are joined.
  matchingReln1 | the 2-by-2 matching matrix that specifies how spaces end1 and centre are joined.

## ~GraphTriple()

regina::GraphTriple::~GraphTriple | ( |  | ) |

Destroys this structure along with the component Seifert fibred spaces and matching matrices.

## Member Function Documentation

## centre()

const SFSpace & regina::GraphTriple::centre | ( |  | ) | const

inline

Returns a reference to the central space.

This is the Seifert fibred space with two boundary components, to which the two end spaces are joined. See the class notes for further discussion.

Returns
  a reference to the requested Seifert fibred space.

## construct()

Triangulation< 3 > * regina::Manifold::construct | ( |  | ) | const

inline virtual inherited

Returns a triangulation of this 3-manifold, if such a construction has been implemented.

If no construction routine has yet been implemented for this 3-manifold (for instance, if this 3-manifold is a Seifert fibred space with sufficiently many exceptional fibres) then this routine will return 0.

The details of which 3-manifolds have construction routines can be found in the notes for the corresponding subclasses of Manifold. The default implemention of this routine returns 0.

Returns
  a triangulation of this 3-manifold, or 0 if the appropriate construction routine has not yet been implemented.

Reimplemented in regina::SFSpace, regina::SnapPeaCensusManifold, regina::LensSpace, and regina::SimpleSurfaceBundle.

## detail()

std::string regina::Output< Manifold , false >::detail | ( |  | ) | const

inherited

Returns a detailed text representation of this object.

This text may span many lines, and should provide the user with all the information they could want. It should be human-readable, should not contain extremely long lines (which cause problems for users reading the output in a terminal), and should end with a final newline. There are no restrictions on the underlying character set.

Returns
  a detailed text representation of this object.

## end()

const SFSpace & regina::GraphTriple::end | ( | unsigned | which | ) | const

inline

Returns a reference to one of the two end spaces.

These are the Seifert fibred spaces with just one boundary component, to be joined to the central space. See the class notes for further discussion.

Parameters

  which | 0 if the first end space is to be returned, or 1 if the second end space is to be returned.

Returns
  a reference to the requested Seifert fibred space.

## homology()

AbelianGroup* regina::GraphTriple::homology | ( |  | ) | const

virtual

Returns the first homology group of this 3-manifold, if such a routine has been implemented.

If the calculation of homology has not yet been implemented for this 3-manifold then this routine will return 0.

The details of which 3-manifolds have homology calculation routines can be found in the notes for the corresponding subclasses of Manifold. The default implemention of this routine returns 0.

The homology group will be newly allocated and must be destroyed by the caller of this routine.

This routine can also be accessed via the alias homologyH1() (a name that is more specific, but a little longer to type).

Returns
  the first homology group of this 3-manifold, or 0 if the appropriate calculation routine has not yet been implemented.

Reimplemented from regina::Manifold.

## homologyH1()

AbelianGroup * regina::Manifold::homologyH1 | ( |  | ) | const

inline inherited

Returns the first homology group of this 3-manifold, if such a routine has been implemented.

If the calculation of homology has not yet been implemented for this 3-manifold then this routine will return 0.

The details of which 3-manifolds have homology calculation routines can be found in the notes for the corresponding subclasses of Manifold. The default implemention of this routine returns 0.

The homology group will be newly allocated and must be destroyed by the caller of this routine.

This routine can also be accessed via the alias homology() (a name that is less specific, but a little easier to type).

Returns
  the first homology group of this 3-manifold, or 0 if the appropriate calculation routine has not yet been implemented.

## isHyperbolic()

bool regina::GraphTriple::isHyperbolic | ( |  | ) | const

inline virtual

Returns whether or not this is a finite-volume hyperbolic manifold.

Returns
  `true` if this is a finite-volume hyperbolic manifold, or `false` if not.

Implements regina::Manifold.

## matchingReln()

const Matrix2 & regina::GraphTriple::matchingReln | ( | unsigned | which | ) | const

inline

Returns a reference to the 2-by-2 matrix describing how the two requested bounded Seifert fibred spaces are joined together.

See the class notes for details on precisely how these matrices are represented.

The argument which indicates which particular join should be examined. A value of 0 denotes the join between the central space and the first end space (corresponding to matrix M in the class notes), whereas a value of 1 denotes the join between the central space and the second end space (corresponding to matrix M' in the class notes).

Parameters

  which | indicates which particular join should be examined; this should be 0 or 1 as described above.

Returns
  a reference to the requested matching matrix.

## name()

std::string regina::Manifold::name | ( |  | ) | const

inherited

Returns the common name of this 3-manifold as a human-readable string.

Returns
  the common name of this 3-manifold.

## operator<() [1/2]

bool regina::Manifold::operator< | ( | const Manifold & | compare | ) | const

inherited

Determines in a fairly ad-hoc fashion whether this representation of this 3-manifold is "smaller" than the given representation of the given 3-manifold.

The ordering imposed on 3-manifolds is purely aesthetic on the part of the author, and is subject to change in future versions of Regina.

The ordering also depends on the particular representation of the 3-manifold that is used. As an example, different representations of the same Seifert fibred space might well be ordered differently.

All that this routine really offers is a well-defined way of ordering 3-manifold representations.

Warning
  Currently this routine is only implemented in full for closed 3-manifolds. For most classes of bounded 3-manifolds, this routine simply compares the strings returned by name().

Parameters

  compare | the 3-manifold representation with which this will be compared.

Returns
  `true` if and only if this is "smaller" than the given 3-manifold representation.

## operator<() [2/2]

bool regina::GraphTriple::operator< | ( | const GraphTriple & | compare | ) | const

Determines in a fairly ad-hoc fashion whether this representation of this space is "smaller" than the given representation of the given space.

The ordering imposed on graph manifolds is purely aesthetic on the part of the author, and is subject to change in future versions of Regina. It also depends upon the particular representation, so that different representations of the same space may be ordered differently.

All that this routine really offers is a well-defined way of ordering graph manifold representations.

Parameters

  compare | the representation with which this will be compared.

Returns
  `true` if and only if this is "smaller" than the given graph manifold representation.

## str()

std::string regina::Output< Manifold , false >::str | ( |  | ) | const

inherited

Returns a short text representation of this object.

This text should be human-readable, should fit on a single line, and should not end with a newline. Where possible, it should use plain ASCII characters.

Python:
  In addition to str(), this is also used as the Python "stringification" function `__str__()`.

Returns
  a short text representation of this object.

## structure()

std::string regina::Manifold::structure | ( |  | ) | const

inherited

Returns details of the structure of this 3-manifold that might not be evident from its common name.

For instance, for an orbit space S^3/G this routine might return the full Seifert structure.

This routine may return the empty string if no additional details are deemed necessary.

Returns
  a string describing additional structural details.

## TeXName()

std::string regina::Manifold::TeXName | ( |  | ) | const

inherited

Returns the common name of this 3-manifold in TeX format.

No leading or trailing dollar signs will be included.

Warning
  The behaviour of this routine has changed as of Regina 4.3; in earlier versions, leading and trailing dollar signs were provided.

Returns
  the common name of this 3-manifold in TeX format.

## utf8()

std::string regina::Output< Manifold , false >::utf8 | ( |  | ) | const

inherited

Returns a short text representation of this object using unicode characters.

Like str(), this text should be human-readable, should fit on a single line, and should not end with a newline. In addition, it may use unicode characters to make the output more pleasant to read. This string will be encoded in UTF-8.

Returns
  a short text representation of this object.

## writeName()

std::ostream& regina::GraphTriple::writeName | ( | std::ostream & | out | ) | const

virtual

Writes the common name of this 3-manifold as a human-readable string to the given output stream.

Python:
  The parameter out does not exist; instead standard output will always be used. Moreover, this routine returns `None`.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::Manifold.

## writeStructure()

std::ostream & regina::Manifold::writeStructure | ( | std::ostream & | out | ) | const

inline virtual inherited

Writes details of the structure of this 3-manifold that might not be evident from its common name to the given output stream.

For instance, for an orbit space S^3/G this routine might write the full Seifert structure.

This routine may write nothing if no additional details are deemed necessary. The default implementation of this routine behaves in this way.

Python:
  The parameter out does not exist; instead standard output will always be used. Moreover, this routine returns `None`.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Reimplemented in regina::SFSpace, and regina::SnapPeaCensusManifold.

## writeTeXName()

std::ostream& regina::GraphTriple::writeTeXName | ( | std::ostream & | out | ) | const

virtual

Writes the common name of this 3-manifold in TeX format to the given output stream.

No leading or trailing dollar signs will be included.

Warning
  The behaviour of this routine has changed as of Regina 4.3; in earlier versions, leading and trailing dollar signs were provided.

Python:
  The parameter out does not exist; instead standard output will always be used. Moreover, this routine returns `None`.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::Manifold.

## writeTextLong()

void regina::Manifold::writeTextLong | ( | std::ostream & | out | ) | const

inline inherited

Writes a detailed text representation of this object to the given output stream.

Subclasses must not override this routine. They should override writeName() and writeStructure() instead.

Python:
  Not present.

Parameters

  out | the output stream to which to write.

## writeTextShort()

void regina::Manifold::writeTextShort | ( | std::ostream & | out | ) | const

inline inherited

Writes a short text representation of this object to the given output stream.

Subclasses must not override this routine. They should override writeName() instead.

Python:
  Not present.

Parameters

  out | the output stream to which to write.

The documentation for this class was generated from the following file:

- manifold/graphtriple.h

Copyright © 1999-2016, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@maths.uq.edu.au).